package com.example.downloadtest2;

import java.io.ByteArrayInputStream;

import com.vaadin.server.DownloadStream;
import com.vaadin.server.ErrorHandler;
import com.vaadin.server.FileDownloader;
import com.vaadin.server.StreamResource;
import com.vaadin.server.VaadinRequest;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Button.ClickListener;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Notification.Type;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

/**
 * Main UI class
 */
@SuppressWarnings("serial")
public class Downloadtest2UI extends UI implements ErrorHandler {

	@Override
	protected void init(VaadinRequest request) {

		final VerticalLayout layout = new VerticalLayout();
		layout.setMargin(true);
		setContent(layout);

		this.getSession().setErrorHandler(this);

		DownloadStreamResource ds = new DownloadStreamResource() {

			@Override
			public DownloadStream getStream() {

				throw new DownloadException("Exception");

				// String a = "test";
				//
				// DownloadStream ds = new DownloadStream(new ByteArrayInputStream(a.getBytes()), "application/text", "aa.txt");
				//
				// return ds;

				// throw new DownloadException("Exception");
				// throw new RuntimeException("Exception");
			}

		};

		DownloadButton downloadButton = new DownloadButton("Download stream");
		downloadButton.setImmediate(true);

		downloadButton.setDownloadStreamResource(ds);

		Button refreshButton = new Button("Refresh");

		// FileDownloader fd = new FileDownloader(ds);
		//
		// fd.extend(refreshButton);

		refreshButton.addClickListener(new ClickListener() {

			@Override
			public void buttonClick(ClickEvent event) {

				Notification.show("Refreshed");
			}
		});

		layout.addComponent(downloadButton);
		layout.addComponent(refreshButton);
	}

	@Override
	public void error(com.vaadin.server.ErrorEvent event) {

		try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		Notification.show("", "Error in getStream", Type.ERROR_MESSAGE);

	}

}