package com.example.downloadtest2;

import java.io.IOException;

import com.vaadin.server.ConnectorResource;
import com.vaadin.server.DownloadStream;
import com.vaadin.server.Resource;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinResponse;

public class TestDownloader extends com.vaadin.server.FileDownloader {

	private static final long serialVersionUID = 1L;

	public TestDownloader(DownloadStreamResource downloadStreamResource) {
		super(downloadStreamResource);
		setResource("dl", downloadStreamResource);
	}

	@Override
	public boolean handleConnectorRequest(VaadinRequest request, VaadinResponse response, String path) throws IOException {

		if (!path.matches("dl(/.*)?")) {
			// Ignore if it isn't for us
			return false;
		}

		Resource resource = getFileDownloadResource();
		if (resource instanceof ConnectorResource) {
			DownloadStream stream = ((ConnectorResource) resource).getStream();

			if (stream == null) {
				return false;
			}

			if (stream.getParameter("Content-Disposition") == null) {
				// Content-Disposition: attachment generally forces download
				stream.setParameter("Content-Disposition", "attachment; filename=\"" + stream.getFileName() + "\"");
			}

			// Content-Type to block eager browser plug-ins from hijacking the
			// file
			if (isOverrideContentType()) {
				stream.setContentType("application/octet-stream;charset=UTF-8");
			}
			stream.writeResponse(request, response);
			return true;
		} else {
			return false;
		}
	}

}
